README

# webpack-log

A common logging module for the Webpack ecosystem. `webpack-log` leverages `loglevelnext`.

## Getting Started

First thing's first, install the module:

npm install webpack-log --save

Note: We do not recommend installing this module globally.

## Requirements

`webpack-log` requires Node v6 or higher.

## Usage

const weblog = require('webpack-log');
const log = weblog({ name: 'wds' }) // webpack-dev-server
log.info('Server Starting');

The code above will produce:

## Options

The default export (`function`) will return a logger, given an `options` Object. The following is a property reference for the Object.

_Note: the logger returned is unique by default, due to the nature of the `webpack` ecosystem. Please reference the `unique` option below for disabling this feature and to force caching._

### level

Type: `String`
Default: ‘'info’`

Specifies the level the logger should use. A logger will not produce output for any log level beneath the specified level. Available levels and order are:

[
'trace',
'debug',
'info',
'warn',
'error',
'silent'
]

Note: The level names shown above correspond to the available logging methods, with the notable exception of the `silent` level.

### name

Required
Type: `String`
Default: ‘’<unknown>'`

Specifies the name of the log to create. This property is required, and used to differentiate between loggers when `webpack-log` is used in multiple projects executing in the same process space.

### timestamp

Type: `Boolean`
Default: `false`

If `true`, instructs the logger to display a timestamp for log output, preceding all other data.

### unique

Type: `Boolean`
Default: `true`

If `false`, instructs the logger to used cached versions of a log with the same name. Due to the nature of the `webpack` ecosystem and multiple plugin/loader use in the same process space, loggers are created as unique instances by default. By passing `false` for this property, the module is instructed to cache the requested logger.

## Contributing

We welcome your contributions! Please have a read of CONTRIBUTING.md for more information on how to get involved.

## License

#### <a href="./LICENSE">MIT</a>